#include <iostream>
using namespace std;
#include "BMPImage.h"
#include <GL/glut.h>

void imageTexture(BMPImage& texImage, GLuint *texID) {
    glDeleteTextures(1, texID);
	glGenTextures(1, texID);
	glBindTexture(GL_TEXTURE_2D, *(texID));

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, texImage.getXSize(), texImage.getYSize(), 0, GL_RGB, GL_UNSIGNED_BYTE, texImage.getData());

}

int loadTexture(char *fileName, GLuint *texID) {
	/* Read filename and create a texture from it, with ID in texID. */
	BMPImage texImage;

	int status = texImage.load(fileName);

	if (status == 1) {
		 imageTexture(texImage, texID); 
	}

	return status;
}